// Decompiled by DJ v3.11.11.95 Copyright 2009 Atanas Neshkov  Date: 29.12.2010 15:46:01
// Home Page: http://members.fortunecity.com/neshkov/dj.html  http://www.neshkov.com/dj.html - Check often for new version!
// Decompiler options: packimports(3) 
// Source File Name:   DomBanner.java

import java.applet.Applet;
import java.awt.*;
import java.util.StringTokenizer;

public class DomBanner extends Applet
    implements Runnable
{

    public void stop()
    {
        myThread.stop();
        myThread = null;
    }

    private void updateMouse()
    {
        if(bHaveMouse)
        {
            int x = (mouseX - x0) % bufDim.width;
            for(int i = 0; i < nEntries; i++)
            {
                if(x < entries[i].paintWidth())
                {
                    entries[i].mouseOver(x, mouseY);
                    break;
                }
                x -= entries[i].paintWidth();
            }

        }
    }

    private void doMouseClick()
    {
        int x = (mouseX - x0) % bufDim.width;
        for(int i = 0; i < nEntries; i++)
        {
            if(x < entries[i].paintWidth())
            {
                entries[i].mouseClick(x, mouseY);
                break;
            }
            x -= entries[i].paintWidth();
        }

    }

    private int stringToInt(String value)
    {
        return Integer.valueOf(value).intValue();
    }

    private Font stringToFont(String value)
    {
        if(value == null)
            throw new IllegalArgumentException("No font was specified");
        StringTokenizer st = new StringTokenizer(value, ",");
        String fontName = st.nextToken().trim();
        int fontSize = Integer.decode(st.nextToken().trim()).intValue();
        int fontType = 0;
        try
        {
            String fontTypeStr = st.nextToken().toLowerCase();
            if(fontTypeStr.indexOf('i') >= 0)
                fontType += 2;
            if(fontTypeStr.indexOf('b') >= 0)
                fontType++;
        }
        catch(Exception e) { }
        return new Font(fontName, fontType, fontSize);
    }

    public void paint(Graphics g)
    {
        if(bufImage == null)
            makeBufImage(g);
        if(bufImage != null)
        {
            for(int x = x0; x < appDim.width; x += bufDim.width)
                g.drawImage(bufImage, x, 0, null);

        }
    }

    public DomBanner()
    {
        backgroundDefault = Color.black;
    }

    public String[][] getParameterInfo()
    {
        String info[][] = {
            {
                "label", "String", "Label string to be displayed"
            }, {
                "font", "font", "Font in which to display the label"
            }, {
                "background", "String", "Background color, format \"rrggbb\""
            }, {
                "foreground", "String", "Foreground color, format \"rrggbb\""
            }, {
                "speed", "String", "Frame rate, in msecs"
            }
        };
        return info;
    }

    public void makeBufImage(Graphics g)
    {
        appDim = size();
        int bufWidth = 0;
        for(int i = 0; i < nEntries; i++)
            bufWidth += entries[i].paintWidth(g);

        if(bufGraphics == null || bufWidth != bufDim.width || appDim.height != bufDim.height)
        {
            bufDim.height = appDim.height;
            bufDim.width = bufWidth;
            bufImage = createImage(bufDim.width, bufDim.height);
            bufGraphics = bufImage.getGraphics();
        }
        bufGraphics.setColor(backgroundColor);
        bufGraphics.fillRect(0, 0, bufDim.width, bufDim.height);
        int textX = 0;
        for(int i = 0; i < nEntries; i++)
        {
            entries[i].paint(bufGraphics, textX, bufDim.height);
            textX += entries[i].paintWidth();
        }

    }

    public void update(Graphics g)
    {
        paint(g);
    }

    private void readParams()
    {
        sep = getParameter("sep", ":");
        labels = getParameter("label", "(Default label)");
        textFonts = getParameter("font", "Helvetica, 24, bold italic");
        foregroundColors = getParameter("foreground", "FFFF00");
        gaps = getParameter("gap", "50");
        hrefs = getParameter("href", "");
        frames = getParameter("frame", "_self");
        hovers = getParameter("hover", "");
        base = getParameter("base", "");
        StringTokenizer stLabels = new StringTokenizer(labels, sep);
        StringTokenizer stFonts = new StringTokenizer(textFonts, sep);
        StringTokenizer stForegrounds = new StringTokenizer(foregroundColors, sep);
        StringTokenizer stGaps = new StringTokenizer(gaps, sep);
        StringTokenizer stHrefs = new StringTokenizer(hrefs, sep);
        StringTokenizer stFrames = new StringTokenizer(frames, sep);
        StringTokenizer stHovers = new StringTokenizer(hovers, sep);
        nEntries = stLabels.countTokens();
        entries = new DomBannerEntry[nEntries];
        String label = "(Default label)";
        Color foregroundColor = stringToColor("FFFF00");
        Font textFont = stringToFont("Helvetica, 24, bold italic");
        int gap = stringToInt("50");
        String href = "";
        String frame = "_self";
        String hover = "";
        for(int i = 0; i < nEntries; i++)
        {
            entries[i] = new DomBannerEntry(this);
            label = stLabels.nextToken();
            try
            {
                foregroundColor = stringToColor(stForegrounds.nextToken());
            }
            catch(Exception e) { }
            try
            {
                textFont = stringToFont(stFonts.nextToken());
            }
            catch(Exception e) { }
            try
            {
                gap = stringToInt(stGaps.nextToken());
            }
            catch(Exception e) { }
            entries[i].setAppearance(label, textFont, foregroundColor, gap);
            try
            {
                href = stHrefs.nextToken();
            }
            catch(Exception e) { }
            try
            {
                frame = stFrames.nextToken();
            }
            catch(Exception e) { }
            try
            {
                hover = stHovers.nextToken();
            }
            catch(Exception e) { }
            entries[i].setLink(base, href, frame, hover);
        }

        try
        {
            backgroundColor = stringToColor(getParameter("background"));
        }
        catch(Exception e)
        {
            backgroundColor = backgroundDefault;
        }
        speed = getParameter("speed", 50);
        step = getParameter("step", 1);
    }

    public void start()
    {
        myThread = new Thread(this);
        myThread.start();
    }

    private String getParameter(String param, String defValue)
    {
        String value;
        try
        {
            value = getParameter(param);
        }
        catch(Exception e)
        {
            value = null;
        }
        if(value == null)
            value = defValue;
        return value;
    }

    private int getParameter(String param, int defValue)
    {
        try
        {
            return stringToInt(getParameter(param));
        }
        catch(Exception e)
        {
            return defValue;
        }
    }

    public void run()
    {
        makeBufImage(getGraphics());
        while(myThread != null) 
        {
            try
            {
                Thread.currentThread();
                Thread.sleep(speed);
            }
            catch(InterruptedException e)
            {
                return;
            }
            x0 -= step;
            if(x0 < -bufDim.width)
                x0 = 0;
            repaint();
            updateMouse();
        }
    }

    public void init()
    {
        readParams();
        x0 = 0;
        bufDim = new Dimension();
    }

    public boolean handleEvent(Event ev)
    {
        if(ev.id == 503)
        {
            bHaveMouse = true;
            mouseX = ev.x;
            mouseY = ev.y;
            updateMouse();
        } else
        if(ev.id == 504)
        {
            bHaveMouse = true;
            updateMouse();
        } else
        if(ev.id == 505)
        {
            bHaveMouse = false;
            updateMouse();
        } else
        if(ev.id == 502)
        {
            bHaveMouse = true;
            doMouseClick();
        }
        return super.handleEvent(ev);
    }

    private Color stringToColor(String value)
    {
        if(value == null)
        {
            throw new IllegalArgumentException("No color was specified");
        } else
        {
            int red = Integer.decode("0x" + value.substring(0, 2)).intValue();
            int green = Integer.decode("0x" + value.substring(2, 4)).intValue();
            int blue = Integer.decode("0x" + value.substring(4, 6)).intValue();
            return new Color(red, green, blue);
        }
    }

    private DomBannerEntry entries[];
    private int nEntries;
    private String sep;
    private final String sepParam = "sep";
    private final String sepDefault = ":";
    private String labels;
    private final String labelParam = "label";
    private final String labelDefault = "(Default label)";
    private String textFonts;
    private final String textFontParam = "font";
    private final String textFontDefault = "Helvetica, 24, bold italic";
    private String foregroundColors;
    private final String foregroundParam = "foreground";
    private final String foregroundDefault = "FFFF00";
    private String gaps;
    private final String gapParam = "gap";
    private final String gapDefault = "50";
    private String hrefs;
    private final String hrefParam = "href";
    private final String hrefDefault = "";
    private String frames;
    private final String frameParam = "frame";
    private final String frameDefault = "_self";
    private String hovers;
    private final String hoverParam = "hover";
    private final String hoverDefault = "";
    private String base;
    private final String baseParam = "base";
    private final String baseDefault = "";
    private Color backgroundColor;
    private final String backgroundParam = "background";
    private final Color backgroundDefault;
    private int speed;
    private final String speedParam = "speed";
    private final int speedDefault = 50;
    private int step;
    private final String stepParam = "step";
    private final int stepDefault = 1;
    private Thread myThread;
    private int x0;
    private Dimension bufDim;
    private Dimension appDim;
    private Image bufImage;
    private Graphics bufGraphics;
    private boolean bHaveMouse;
    private int mouseX;
    private int mouseY;
}
